<?php
require_once( "../../db.php" );
//require_once( "useSingleton.php" );
/**
 * Methods for database handling.
 */
class Login extends Db  {

   
    const BCRYPT_COST = 14;
	
	public $username;
	public $password;
	public $role;
	public $exist;
	 
	 
	 public function __construct() {

   }
	 
	 
    

    /**
     * Gets given users password.
     *
     * @param $username The username to get the password of.
     * @return The password of the given user.
     */
    public function getUsersPassword($username) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT password
                FROM   aclogin
                WHERE  username = :username';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':username', $username);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];

       parent::DisConnect( $MySQLiconn);

        return $this->password;
    }

    /**
     * Creates a new user.
     *
     * @param $username The username to create.
     * @param $password The password of the user.
     */
    public function createaclogin($username,$password,$role,$email) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
       $sql = "INSERT INTO aclogin (username,password,role,email)
                VALUES (:username, :password, :role, :email)";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':username',$username, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        $statement->bindValue(":role", $role,  PDO::PARAM_STR);
		$statement->bindValue(":email", $email , PDO::PARAM_STR);
	
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }
	
	
	
	
	public function countAll(){
	$instance = parent::getInstance();
		//$instance = new DBAccess();
       $MySQLiconn  = $instance->getConnection();	
 
   $sql = "SELECT * from members";
				$statement = $MySQLiconn->prepare($sql);
    $statement->execute();
 
    $num = $statement->rowCount();
 
    return $num;
	parent::DisConnect( $MySQLiconn);
}







public function getUsersPassword2($username) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   aclogin
                WHERE  username = :username';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':username', $username);

        $statement->execute();
		$row = $statement->fetch(PDO::FETCH_ASSOC);
	
	   $this->role = $row['role'];
     $this->password = $row['password'];
 
    return $this->role;
        
      
		 parent::DisConnect( $MySQLiconn);
		
    }

   public function getPassword(){
	   return $this->password ;
	   }
	   
	 public function getRole(){
	   return $this->role ;
	   }   
	
	
	
	 public function updateacloginDetails($username,$password) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
    //   $sql = "INSERT INTO aclogin (staffno,password,role,email,textcode,password2)
              //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
			  
			  $sql = "UPDATE aclogin SET password = :password WHERE username = :username";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':username',$username, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        
		
		
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }



    public function changeRole($username,$role) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
     //   $sql = "INSERT INTO aclogin (staffno,password,role,email,textcode,password2)
               //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
         
         $sql = "UPDATE aclogin SET role = :role WHERE username = :username";
           
 
       
         $statement = $MySQLiconn->prepare($sql);
   
         $statement->bindValue(':username',$username, PDO::PARAM_STR );
     
         $statement->bindValue(":role", $role, PDO::PARAM_STR);
         
     
     
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }
	
	
	
	
		
	
	
	
	public function checkStaffid($staffno){
	  
	  $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   aclogin
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $staffno);

        $statement->execute();
		//$row = $statement->fetch(PDO::FETCH_ASSOC);
		
     
	  $num = $statement->rowCount();
	 
 
    return $num;
        
      
		 parent::DisConnect( $MySQLiconn);
	  	
		
		} 	
	
	
	 public function deleteStaffaclogin($username){
		
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'DELETE 
                FROM   aclogin
                WHERE  username = :username';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':username', $username);

        $statement->execute();  
		  parent::DisConnect( $MySQLiconn);
		}		
	
	

	
	
	
}